/*******************************************************************************
 *  Copyright 2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_PosteriorAcousticFeatures;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_PosteriorAcousticFeatures;


/**
 * This class represents PosteriorAcousticFeatures - CID6155
 */
public class PosteriorAcousticFeatures_CID6155 
{
	
	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * Instantiates a new PosteriorAcousticFeatures_CID6155 Template 
	 */
	public PosteriorAcousticFeatures_CID6155()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}

	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumPosteriorAcousticFeatures Object of EnumCM_PosteriorAcousticFeatures represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_PosteriorAcousticFeatures enumPosteriorAcousticFeatures)
	{
		switch(enumPosteriorAcousticFeatures)
		{
		case NO_POSTERIOR_ACOUSTIC_FEATURES:
			this.strCodeValue = EnumCV_PosteriorAcousticFeatures.NO_POSTERIOR_ACOUSTIC_FEATURES_111367
					.getValue();
			break;
		case POSTERIOR_ENHANCEMENT:
			this.strCodeValue = EnumCV_PosteriorAcousticFeatures.POSTERIOR_ENHANCEMENT_111368
					.getValue();
			break;
		case POSTERIOR_SHADOWING:
			this.strCodeValue = EnumCV_PosteriorAcousticFeatures.POSTERIOR_SHADOWING_111369
					.getValue();
			break;
		case COMBINED_POSTERIOR_ENHANCEMENT_AND_SHADOWING:
			this.strCodeValue = EnumCV_PosteriorAcousticFeatures.COMBINED_POSTERIOR_ENHANCEMENT_AND_SHADOWING_111370
					.getValue();
			break;
		}
	}

	/**
	 * Sets the value for PosteriorAcousticFeatures
	 * @param enumPosteriorAcousticFeatures Object of EnumCM_PosteriorAcousticFeatures.
	 */
	public void setPosteriorAcousticFeatures(EnumCM_PosteriorAcousticFeatures enumPosteriorAcousticFeatures)
	{
		/**
		 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion and Code Meaning and 
		 * sets the Code Value according to Code Meaning.
		 */
		this.strCodeMeaning = enumPosteriorAcousticFeatures.getValue();
		this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.DCM.getValue();
		
		/**
		 * set code Value
		 */
		setCodeValue(enumPosteriorAcousticFeatures);
	}
}
